;
; vz dumper. djm. v4. 5/mar/2k9.
; dumps vz .DSK to an output text file. 
; Quick and dirty!
;
; VZDSKDUMP <in.dsk> <out.txt>
; VZDSKDUMP GAMES.DSK GAMES_DISK3.TXT
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; INFO:
; VZ directory occupies Track 0, Sector 0 through to the end of sector 14.
; Sector 0, Track 15 contains pointers to something. forget.
; ....meaning that the directory size is 1920 bytes, and can contain a maximum of 112 filenames per side of a disk.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  File type 1 byte
;  Delimitor (3AH) 1 byte
;  File name 8 byte
;  Start address 2 byte
;  End address 2 byte
;  Start track 1 byte
;  Start sector 1 byte
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; 2688 bytes
;

        	IDEAL
        	MODEL   small
        	STACK   256
cr      	EQU     13              ; ASCII carriage return
lf      	EQU     10              ; ASCII line feed
ASCnull         EQU     0               ; ASCII null character

        DATASEG
_crlf		db	13,10,0
_del2		db	'?',0
_spaces		db	'    ',0
_spaces2	db	' ',0
inFile          DW      0       ; Input file handle
outFile         DW      0       ; Output file handle
file		db	0,0
oneByte         Db      0,0,0,0,0,0,0,0       ; Byte I/O variable
s_track		db	0
e_track		db	0
s_address	db	0,0
e_address	db	0,0

s_track2	db	0,0,0,0
e_track2	db	0,0,0,0
s_address2	db	0,0,0,0
e_address2	db	0,0,0,0

tempbyte	db	0,0
exCode          DB      0
buffer		db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1
		DB	'xxxxxxxxxxx'
diskFull        DB      cr,lf,'**ERROR: Disk is full', 0
prompt          DB      cr,lf,'Erase this file? (y/n) ', 0
notes   	DB      cr,lf,'VZ disk dumper. v4.0. By dave. 5/Mar/2K9.'
      	  	DB      cr,lf,'Dumps the directory of a VZ .DSK file to a text file.'
        	DB      cr,lf,'VZDSKDUMP <in.dsk> <out.txt>',cr,lf
	        DB      cr,lf,'ie:  VZDSKDUMP GAMES.DSK GAMES.TXT',cr,lf,0



        CODESEG
        EXTRN StrWrite:Proc, NewLine:Proc				;-----  From STRIO.OBJ
        EXTRN DiskErr:Proc						;-----  From DISKERR.OBJ
        EXTRN GetParams:Proc, ParamCount:Proc, GetOneParam:Proc		;-----  From PARAMS.OBJ


Start:  mov     ax, @data               ; Set ax to data segment
        mov     es, ax                  ; Set es to data segment
        call    GetParams               ; Get parameters with ds = PSP
        call    ParamCount              ; Get number of parameters (dx)
        cmp     dx, 2                   ; Does count = 2?
        je      @@10                    ; Continue if param count = 2
        mov     di, offset notes        ; Address text with di
        call    StrWrite                ; Display notes
        jmp     Exit                    ; Exit program

@@10:   xor     cx, cx                  ; Specify parameter number 0
        call    GetOneParam             ; Get address of parameter string
        mov     dx, di                  ; Address file name with ds:dx
        xor     al, al                  ; Specify read-only access
        mov     ah, 3Dh                 ; DOS Open-file function
        int     21h                     ; Open the input file
        jnc     @@20                    ; Continue if no error
        jmp     Errors                  ; Else jump to error handler

@@20:   mov     [inFile], ax            ; Save input file handle
        mov     cx, 1                   ; Specify parameter number 1
        call    GetOneParam             ; Get address of parameter string
        mov     dx, di                  ; Address file name with ds:dx
        xor     al, al          ; Specify read-only access
        mov     ah, 3Dh         ; DOS Open-file function
        int     21h             ; Call DOS to open the file
        jc      @@21            ; Exit--file doesn't exist
        mov     bx, ax          ; Copy handle to bx
        mov     ah, 3Eh         ; DOS Close-file function
        int     21h             ; Close the file
        clc                     ; Clear carry flag (file exists)
@@21:   jc      @@30                    ; Jump if file does not exist
        call    StrWrite                ; Display file name
@@22:   mov     di, offset Prompt       ; Address prompt string
        call    StrWrite                ; Display message
        mov     ah, 1                   ; DOS GetChar function
        int     21h                     ; Get user response
        cmp     al, 'Y'                 ; Compare with Y
        je      @@24                    ; Exit if char = Y
        cmp     al, 'y'                 ; Compare with y
        je      @@24                    ; Exit if char = y
        cmp     al, 'N'                 ; Compare with N
        je      @@23                    ; Handle No response
        cmp     al, 'n'                 ; Compare with n
        jne     @@22                ; Repeat if not Y, y, N, n
@@23:   cmp     al, '@'                 ; Reset zero flag (zf=0)
@@24:   je      @@30                    ; Continue if permission given
        jmp     Exit                    ; Else exit program
@@30:   mov     cx, 1                   
        call    GetOneParam             
        mov     dx, di                  
        xor     cx, cx                  
        mov     ah, 3Ch                 
        int     21h                     
        jnc     @@40                    
        jmp     Errors                  
@@40:   mov     [outFile], ax           
	mov	bp, 25
	mov	cx, 25
@@50:   call	readbyte
	loop	@@50

;--------------------------------------------------------------------------
;	 T:XXXXXXXX    9 9 9XXX 9XXXCR
;	 123456789012345678901234567890
;       	   1         2         3     

;	-CHIP 8-	01 00 7AE9 7AEB
;	--------	01 01 7AE9 7AEB
;       c8ED LDR	01 02 7AE9 8ADF

;       ax = 16-bit value to convert
;       bx = base for result (2=binary;10=decimal;16=hex)
;       cx = minimum number of digits to output
;       di = address of string to hold result
;	call	numtoascii

;       ax = 16-bit value to convert
;       cx = minimum number of digits to output
;       di = address of string to hold result

@@60:	call	@@_0
	call	@@_0
	call	@@_0
	call	@@_0
	call	@@_0
	call	@@_0
	call	@@_0
	call	@@_0

	mov	cx, 334
@@61:   call	readbyte
	loop	@@61
	add	bp, 334
  	cmp	bp, 1920		; done reading first 1920 bytes (size of directory of VZ disk)
	jl	@@60
	jmp	@@80			; so now go bye bye and exit.			


@@_0:	mov     ah, 3Fh                 ; READ char. 
        mov     bx, [inFile]             
        mov     cx, 16                   
        mov     dx, offset file
        int     21h                      
        jnc     @@65                     
        jmp     Errors                   
@@65:	add	bp, 16
  	cmp	bp, 1920		; done reading first 1920 bytes (size of directory of VZ disk)
	jl	@@66
	jmp	@@80			; so now go bye bye and exit.			
@@66:  	mov	si, offset file
	mov	di, offset buffer
	mov	cx, 10
	rep	movsb
	mov	si, offset buffer
	mov	al, [si]
	cmp	al, 00h			; anything there?
	jne	@@67
	jmp	@@80
@@67:	cmp	al, 01h			; deleted filename item?
	jne	@@68
	mov	al, '?'			; If yes, write '?'
	mov	[si], al
@@68:	mov	al, 020h		; display 4 spaces
	mov	cx, 4
	rep	stosb
	mov	si, offset s_track	; read 8 char filename, 1x S-track, 1x E-Track, 2x S-add, 2x E-add.
	call	@@_1
	call	@@_2
	mov	si, offset e_track
	call	@@_1
	call	@@_2
	mov	si, offset s_address+1
	call	@@_1
	mov	si, offset s_address
	call	@@_1
	call	@@_2
	mov	si, offset e_address+1
	call	@@_1
	mov	si, offset e_address
	call	@@_1
	mov	al, 0dh
	stosb
	mov	al, 0ah
	stosb
        mov     cx, 31
        mov     dx, offset buffer
        mov     ah, 40h                 ; DOS Write-file function
        mov     bx, [outFile]           ; Set bx to output file handle
        int     21h			; Call DOS to write to file
        jnc     @@wb2
        jmp     Errors                 
@@wb2:	ret
	


@@_1:	mov	al, [si]
	mov	ah, 0
	mov	cx, 2
	call	BinToAscHex
	inc	di
	inc	di
	ret

@@_2:	mov	al, 020h		; display 1 space
	mov	cx, 1
	rep	stosb
	ret

@@80:   mov     bx, [inFile]            ; Get input file handle
        mov     ah, 3Eh                 ; DOS Close-file function
        int     21h                     ; Close input file
        mov     bx, [outFile]           ; Get output file handle
        mov     ah, 3Eh                 ; DOS Close-file function
        int     21h                     ; Close output file
        jnc     Exit                    ; Exit if no errors detected
        jmp     Errors                  ; Else jump to error handler
Exit:   mov     ah, 04Ch                ; DOS function: Exit program
        mov     al, [exCode]            ; Return exit code value
        int     21h                     ; Call DOS. Terminate program
Errors: mov     [exCode], al            ; Save error code
        call    DiskErr                 ; Display error message
        jmp     Exit                    ; Exit program




PROC 	readbyte
	push	cx
	mov     ah, 3Fh                 ; DOS Read-file function
        mov     bx, [inFile]            ; Set bx to input file handle
        mov     cx, 1                   ; Specify one byte to read
        mov     dx, offset oneByte      ; Address variable with ds:dx
        int     21h                     ; Call DOS to read from file
	mov     di, offset oneByte
	mov	al, [di]
	pop	cx
	ret
ENDP	readbyte




PROC    BinToAscHex
        push    bx              ; Save bx on stack
        mov     bx, 16          ; Set base = 16 (hex)
        push    dx              ; Save some modified registers
        push    di
        push    si
        xor     si, si          ; Set digit-count to zero
        jcxz    @@b            ; If cx=0, jump to set cx=1
@@a:    xor     dx, dx          ; Extend ax to 32-bit dxax
        div     bx              ; ax<-axdx div bx; dx<-remainder
        cmp     dl, 10          ; Is dl < 10 (i.e. hex 'A')?
        jb      @@e            ; If yes, jump
        add     dl, 'A'-10      ; Else convert to A, B, C, D, E, or F
        jmp	@@f                     ; Return to caller
@@e:    or      dl, '0'         ; Convert digits 0 to 9
@@f:    push    dx              ; Save digit on stack
        inc     si              ; Count digits on stack
        loop    @@a            ; Loop on minimum digit count
@@b:    inc     cx              ; Set cx = 1 in case not done
        or      ax, ax          ; Is ax = 0? (all digits done)
        jnz     @@a            ; If ax <> 0, continue conversion
        mov     cx, si          ; Set cx to stack char count
        jcxz    @@d            ; Skip next loop if cx=0000
        cld                     ; Auto-increment di for stosb
@@c:    pop     ax              ; Pop next digit into al
        stosb                   ; Store digit in string; advance di
        loop    @@c            ; Loop for cx digits
@@d:    mov     [byte di], ASCnull      ; Store null at end of string
        pop     si              ; Restore saved registers
        pop     di
        pop     dx
        pop     bx              ; Restore bx
        ret                     ; Return to caller
ENDP    BinToAscHex


        END     Start        ; End of program / entry point
